﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CoolKidEngine.Display
{
	public abstract class DisplayObject
	{
		public bool IsActive = false;

		public Texture2D Texture { get; protected set; }

		public DisplayObject(Texture2D texture)
		{
			Texture = texture;
		}

		public abstract void Update(GameTime time);

		public abstract void Draw(SpriteBatch sb, GameTime time);

		protected virtual object CloneInternal(object obj)
		{
			DisplayObject displayObj = (DisplayObject)obj;
			displayObj.IsActive = IsActive;
			return displayObj;
		}

		public abstract object Clone();
	}
}
