﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Utility;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace CoolKidEngine.Menu
{
	public class Button : Label
	{
		Action ButtonClickAction = null;

		public Button(Texture2D texture, Rectangle destRect, Color color, SpriteFont font, Color fontColor, string text, Action buttonAction = null)
			: base(texture, destRect, color, font, fontColor, text)
		{
			ButtonClickAction = buttonAction;
		}

		public void SetButtonAction(Action buttonAction)
		{
			ButtonClickAction = buttonAction;
		}

		public void ClickButton(Point mousePosition)
		{
			if (CollisionHelper.RectToPoint(DestRectangle, mousePosition))
			{
				ButtonClickAction();
			}
		}

		protected override object CloneInternal(object obj)
		{
			return base.CloneInternal(obj);
		}

		public override object Clone()
		{
			return CloneInternal(new Button(Texture, DestRectangle, Color, Font, FontColor, Text, ButtonClickAction));
		}
	}
}
