﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RitualisticCapitalism.AssetsManagement
{
	public class BuildingConfig : AssetConfig
	{
		public List<string> FacilityNames
		{
			get { return Config.ConfigSettings["Facilities"]; }
		}

		private decimal? m_Upkeep = null;
		public decimal Upkeep
		{
			get
			{
				if (!m_Upkeep.HasValue)
				{
					decimal temp = 0m;
					decimal.TryParse(Config.ConfigSettings["Upkeep"].FirstOrDefault(), out temp);
					m_Upkeep = temp;
				}
				return m_Upkeep.Value;
			}
		}

		private bool? m_IsCity = null;
		public bool IsCity
		{
			get
			{
				if (!m_IsCity.HasValue)
				{
					bool temp = false;
					bool.TryParse(Config.ConfigSettings["IsCity"].FirstOrDefault(), out temp);
					m_IsCity = temp;
				}
				return m_IsCity.Value;
            }
		}

		private bool? m_IsBuildable = null;
		public bool IsBuildable
		{
			get
			{
				if (!m_IsBuildable.HasValue)
				{
					bool temp = false;
					bool.TryParse(Config.ConfigSettings["IsBuildable"].FirstOrDefault(), out temp);
					m_IsBuildable = temp;
				}
				return m_IsBuildable.Value;
			}
		}

		private bool? m_IsSellable = null;
		public bool IsSellable
		{
			get
			{
				if (!m_IsSellable.HasValue)
				{
					bool temp = false;
					bool.TryParse(Config.ConfigSettings["IsSellable"].FirstOrDefault(), out temp);
					m_IsSellable = temp;
				}
				return m_IsSellable.Value;
			}
		}

		public BuildingConfig(ConfigManager config)
			:base(config)
		{

		}
	}
}
