﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RitualisticCapitalism
{
	public class ConfigManager
	{
		public string ConfigPath { get; private set; }
		public Dictionary<string, List<string>> ConfigSettings { get; private set; }
		public ConfigManager()
		{
			ConfigSettings = new Dictionary<string, List<string>>();
		}

		public bool LoadSettings(string configPath)
		{
			ConfigPath = configPath;
			string currentSection = "Default";
			ConfigSettings.Clear();
			ConfigSettings.Add(currentSection, new List<string>());

			if (File.Exists(configPath))
			{
				using (StreamReader reader = new StreamReader(ConfigPath))
				{
					while(!reader.EndOfStream)
					{
						string line = reader.ReadLine();
						string cleanLine = ConfigHelper.CleanLine(line);
						if (line.IndexOf('[') == 0 && line.Contains(']'))
						{
							if (!ConfigSettings.ContainsKey(cleanLine))
								ConfigSettings.Add(cleanLine, new List<string>());
							currentSection = cleanLine;
						}
						else
							ConfigSettings[currentSection].Add(cleanLine);
					}
				}
			}
			else
				return false;
			return true;
		}
	}

	public static class ConfigHelper
	{
		public static string CleanLine(string line)
		{
			return line.Replace("[", "").Replace("]", "");
		}
	}
}
