﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;

namespace RitualisticCapitalism.AssetsManagement
{
	public class CorperationConfig : AssetConfig
	{
		private Color? m_CorperateColor = null;
		public Color CorperateColor
		{
			get
			{
				if (!m_CorperateColor.HasValue)
				{
					string value = Config.ConfigSettings["Color"].FirstOrDefault();
					if (value == null)
						return Color.White;
					string[] splitValue = value.Split(new char[] { ',' });
					if(splitValue.Length > 2)
					{
						int red, green, blue;
						if (!int.TryParse(splitValue[0], out red))
							red = 0;
						if (!int.TryParse(splitValue[1], out green))
							green = 0;
						if (!int.TryParse(splitValue[2], out blue))
							blue = 0;
						if (red > 255) red = 255;
						if (green > 255) green = 255;
						if (blue > 255) blue = 255;

						m_CorperateColor = new Color(red, green, blue, 255);
					}
				}
				return m_CorperateColor.Value;
            }
		}

		public CorperationConfig(ConfigManager config)
			: base(config)
		{

		}
	}
}
