﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RitualisticCapitalism.AssetsManagement
{
	public class ItemConfig : AssetConfig
	{
		public string PluralName
		{
			get
			{
				var target = Config.ConfigSettings["Name"];
				if (target.Count > 1)
					return Config.ConfigSettings["Name"][1];
				else
					return Name;
			}
		}

		private bool m_GetInputItems = true;
		private List<Tuple<string, int>> m_InputItems = new List<Tuple<string, int>>();
		public List<Tuple<string, int>> InputItems
		{
			get
			{
				if (!m_GetInputItems)
					return m_InputItems;

				var target = Config.ConfigSettings["Input"];
				foreach(var item in target)
				{
					if (item.ToUpper() == "NULL")
						break;
					string[] splits = item.Split(new char[] { '=' });
					int temp = 0;
					if (splits.Length < 2)
						break;
					int.TryParse(splits[1].Trim(), out temp);
					m_InputItems.Add(new Tuple<string, int>(splits[0].Trim(), temp));
				}

				m_GetInputItems = false;
				return m_InputItems;
			}
		}

		public int OutputAmount
		{
			get
			{
				string target = Config.ConfigSettings["Output"].FirstOrDefault();
				if (target == null || target == "")
					return 0;
				int temp = 0;
				int.TryParse(target, out temp);
				return temp;
			}
		}

		public int ItemQuality
		{
			get
			{
				string target = Config.ConfigSettings["Quality"].FirstOrDefault();
				if (target == null || target == "")
					return 0;
				int temp = 0;
				int.TryParse(target, out temp);
				return temp;
			}
		}

		public int ItemSize
		{
			get
			{
				string target = Config.ConfigSettings["Size"].FirstOrDefault();
				if (target == null || target == "")
					return 0;
				int temp = 0;
				int.TryParse(target, out temp);
				return temp;
			}
		}

		public string Category
		{
			get { return Config.ConfigSettings["Category"].FirstOrDefault(); }
		}

		public ItemConfig(ConfigManager config)
			:base(config)
		{

		}
	}
}
