﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RitualisticCapitalism.AssetsManagement
{
	public class MapConfig
	{
		public string Name
		{
			get { return Config.ConfigSettings["Name"].FirstOrDefault(); }
		}

		public int MapSize
		{
			get
			{
				int temp = 0;
				int.TryParse(Config.ConfigSettings["Size"].FirstOrDefault(), out temp);
                return temp;
			}
		}

		private bool m_GetCityLocations = true;
		private List<Tuple<int, int>> m_CityLocations = new List<Tuple<int, int>>();
		public List<Tuple<int, int>> CityLocations
		{
			get
			{
				if (!m_GetCityLocations)
					return m_CityLocations;

				var target = Config.ConfigSettings["Cities"];
				foreach(var line in target)
				{
					int x = -1;
					int y = -1;
					string[] lineSplit = line.Split(new char[] { ',' });
					if (lineSplit.Length < 2)
						break;
					int.TryParse(lineSplit[0], out x);
					int.TryParse(lineSplit[1], out y);
					if (x < 0 || y < 0)
						break;
					m_CityLocations.Add(new Tuple<int, int>(x, y));
				}
				m_GetCityLocations = false;
				return m_CityLocations;
			}
		}

		ConfigManager Config;
		public MapConfig(ConfigManager config)
		{
			Config = config;
		}
	}
}
