﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Display;
using CoolKidEngine.Menu;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using RitualisticCapitalism.AssetsManagement;

namespace RitualisticCapitalism
{
	public class Building : GameTileObject
	{
		public LimitedTileMap InteriorMap = null;
		public Menu InteriorMenu = null;

		public Building(BuildingConfig config)
			:base(config)
		{

		}

		public void SetupBuilding(InteriorTile baseTile, Rectangle boundingBox,
			Menu menu, int limitSize)
		{
			InteriorMap = new LimitedTileMap(baseTile, boundingBox, limitSize);
#warning only works when the grid is expected to be 7
			Vector2 tileAbove = InteriorMap.GetTileCenter(4);
			InteriorMap.MoveTile(limitSize - 1, tileAbove + new Vector2(0, baseTile.DestRectangle.Height));
			InteriorMenu = menu; //Changed to not clone because we're passing a fresh menu
		}

		public override object CloneInternal(object obj)
		{
			Building buildingObj = (Building)base.CloneInternal(obj);
			if(InteriorMenu != null)
				buildingObj.InteriorMenu = (Menu)InteriorMenu.Clone();
			buildingObj.InteriorMap = null; //Call setup building
			return buildingObj;
		}

		public override object Clone()
		{
			return CloneInternal(new Building((BuildingConfig)SourceConfig));
		}
	}
}
