﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Display;
using CoolKidEngine.Menu;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace RitualisticCapitalism
{
	public class LandTile : Tile
	{
		public Player Owner = null;
		public Building Building { get; protected set; }

		public LandTile(Texture2D texture, Rectangle destRect, Color color)
			: base(texture, destRect, color)
		{
			Building = null;
		}

		public void SetBuilding(Building building)
		{
			Building = (Building)building.Clone();
			Building.Center = this.Center;
		}

		public void SetBuilding(Building building, InteriorTile tile, Rectangle bounds, Menu menu, int limitSize)
		{
			Building = (Building)building.Clone();
			Building.SetupBuilding(tile, bounds, menu, limitSize);
			Building.Center = this.Center;
		}

		public override void Draw(SpriteBatch sb, GameTime time)
		{
			base.Draw(sb, time);

			if(Building != null)
				Building.Draw(sb, time);

			if (Owner != null)
				Owner.DrawLogo(this.Position, sb, time);
		}

		public override object Clone()
		{
			return CloneInternal(new LandTile(Texture, DestRectangle, Color));
		}
	}
}
