﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Display;
using CoolKidEngine.Menu;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using RitualisticCapitalism.AssetsManagement;

namespace RitualisticCapitalism
{
	public class Player
	{
		public decimal Money { get; set; }
		public List<decimal> MoneyHistory { get; set; }

		public bool IsAI = false;
		Sprite CorperateLogo = null;

		public CorperationConfig CorperateConfig { get; protected set; }
		public Player(CorperationConfig corpConfig)
		{
			CorperateConfig = corpConfig;
			MoneyHistory = new List<decimal>();
		}

		public void Load(GraphicsDevice device, int logoSize)
		{
			using (FileStream stream = new FileStream(CorperateConfig.FinalImagePath, FileMode.Open))
			{
				Texture2D texture = Texture2D.FromStream(device, stream);
				CorperateLogo = new Sprite(texture, new Rectangle(0, 0, logoSize, logoSize), CorperateConfig.CorperateColor);
			}
		}

		public void DrawLogo(Vector2 pos, SpriteBatch sb, GameTime time)
		{
			if (CorperateLogo != null)
			{
				CorperateLogo.Position = pos;
				CorperateLogo.Draw(sb, time);
			}
		}
	}
}
