﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Display;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace RitualisticCapitalism
{
	public class InteriorTile : Tile
	{
		public Facility Facility { get; protected set; }
		public Item Item { get; protected set; }
		public int ItemAmount { get; set; }
		public int ItemPrice { get; set; }

		protected InteriorTile BuySource { get; set; }

		public InteriorTile(Texture2D texture, Rectangle destRect, Color color)
			: base(texture, destRect, color)
		{ }

		public void SetBuySource(InteriorTile tile)
		{
			BuySource = tile;
			Item = (Item)BuySource.Item.Clone();
			Item.Center = this.Center;
		}

		public void SetFacility(Facility facility)
		{
			Facility = (Facility)facility.Clone();
			Facility.Center = this.Center;
		}

		public void RemoveFacility()
		{
			Facility = null;
			Item = null;
			BuySource = null;
		}

		public void SetItem(Item item, int amount)
		{
			Item = (Item)item.Clone();
			Item.Center = this.Center;
			ItemAmount = amount;
		}

		public override void Draw(SpriteBatch sb, GameTime time)
		{
			base.Draw(sb, time);

			if (Facility != null)
				Facility.Draw(sb, time);

			if (Item != null)
				Item.Draw(sb, time);
		}

		public override object Clone()
		{
			return CloneInternal(new InteriorTile(Texture, DestRectangle, Color));
		}
	}
}
