﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CoolKidEngine.Display;
using Microsoft.Xna.Framework;

namespace RitualisticCapitalism
{
	public class LimitedTileMap : TileMap
	{
		public int LimitSize = -1;

		public LimitedTileMap(Tile baseTile, Rectangle boundingBox, int limit)
			: base(baseTile, boundingBox)
		{
			LimitSize = limit;
			if (LimitSize > -1 && m_TileList.Count > LimitSize)
			{
				int count = m_TileList.Count - LimitSize;
				m_TileList.RemoveRange(LimitSize, count);
			}
		}

		public void MoveTile(int index, Vector2 pos)
		{
			m_TileList[index].Center = pos;
		}

		public Vector2 GetTileCenter(int index)
		{
			return m_TileList[index].Center;
		}
	}
}
